/*
 *
 * Copyright (c) 2007 Steve Bennett <steveb@workware.net.au>
 *
 * Simple test client to communicate with toppyd
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/un.h>
#include <sys/socket.h>
#include <unistd.h>
#include <fcntl.h>

int main(int argc, char *argv[])
{
	struct sockaddr_un addr;
	int s;
	FILE *fh;

	/* Create the unix domain socket */
	s = socket(AF_UNIX, SOCK_STREAM, 0);
	if (s < 0) {
		perror("socket");
		return 1;
	}

	/* And connect to /tmp/toppyd */
	/* REVISIT: Really should be toppyd.<devindex> */
	strcpy(addr.sun_path, "/tmp/toppyd");
	addr.sun_family = AF_UNIX;
	if (connect(s, (struct sockaddr *)&addr, strlen(addr.sun_path) + 1 + sizeof(addr.sun_family)) != 0) {
		perror("connect");
		return 1;
	}

	/* Make it easy to read from the socket */
	fh = fdopen(s, "r");

	while (1) {
		char *pt;
		char buf[256];

		fputs("toppyd> ", stdout);
		fflush(stdout);
		if (fgets(buf, sizeof(buf), stdin) == 0) {
			putchar('\n');
			break;
		}

		pt = strchr(buf, '\n');
		if (pt) {
			*pt = 0;
		}
		if (*buf == 0) {
			continue;
		}
		if (write(s, buf, strlen(buf)) <= 0) {
			printf("Failed to send to toppyd\n");
			break;
		}

		/* Read the response */
		while ((fgets(buf, sizeof(buf), fh)) != 0) {
			fputs(buf, stdout);
			if (*buf != '\t') {
				break;
			}
		}
	}

    return 0;
}
